<!DOCTYPE html>

<html lang="en">

<head>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1">
    <title>Task 68</title>

    <!-- Google Font: Source Sans Pro -->
    <link rel="stylesheet"
        href="https://fonts.googleapis.com/css?family=Source+Sans+Pro:300,400,400i,700&display=fallback">
    <!-- Font Awesome Icons -->
    <link rel="stylesheet" href="plugins/fontawesome-free/css/all.min.css">
    <!-- Theme style -->
    <link rel="stylesheet" href="dist/css/adminlte.min.css">
    <link rel="stylesheet" href="https://cdn.datatables.net/1.10.24/css/dataTables.bootstrap4.min.css">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.4.0/css/all.min.css">
</head>

<body class="hold-transition sidebar-mini">

    <div class="wrapper">
        <!-- Navbar -->
        <nav class="main-header navbar navbar-expand navbar-white navbar-light">
            <!-- Left navbar links -->
            <ul class="navbar-nav">
                <li class="nav-item">
                    <a class="nav-link" data-widget="pushmenu" href="#" role="button"><i class="fas fa-bars"></i></a>
                </li>
                <li class="nav-item d-none d-sm-inline-block">
                    <a href="#" class="nav-link">Home</a>
                </li>
            </ul>
        </nav>
        <!-- /.navbar -->
        <!-- Main Sidebar Container -->
        <aside class="main-sidebar sidebar-dark-primary elevation-4">
            <!-- Brand Logo -->
            <a href="#" class="brand-link">
                <img src="dist/img/AdminLTELogo.png" alt="AdminLTE Logo" class="brand-image img-circle elevation-3"
                    style="opacity: .8">
                <span class="brand-text font-weight-light">Devcamp 120</span>
            </a>

            <!-- Sidebar -->
            <div class="sidebar">
                <!-- Sidebar user panel (optional) -->
                <div class="user-panel mt-3 pb-3 mb-3 d-flex">
                    <div class="image">
                        <img src="dist/img/user2-160x160.jpg" class="img-circle elevation-2" alt="User Image">
                    </div>
                    <div class="info">
                        <a href="#" class="d-block">Hồ Bá TRường</a>
                    </div>
                </div>


                <!-- Sidebar Menu -->
                <nav class="mt-2">
                    <ul class="nav nav-pills nav-sidebar flex-column" data-widget="treeview" role="menu"
                        data-accordion="false">
                        <!-- Add icons to the links using the .nav-icon class
               with font-awesome or any other icon font library -->
                        <li class="nav-item menu-open">
                            <a href="Region.html" class="nav-link click-region">
                                <i class="nav-icon fas fa-tachometer-alt"></i>
                                <p>
                                    Quay về Region
                                    <i class="right fas fa-angle-left"></i>
                                </p>
                            </a>
                        </li>
                        <li class="nav-item">
                            <a href="District.html" class="nav-link active">
                                <i class="far fa-circle nav-icon"></i>
                                <p>
                                    District list
                                </p>
                            </a>
                        </li>
                    </ul>
                </nav>
                <!-- /.sidebar-menu -->
            </div>
            <!-- /.sidebar -->
        </aside>
        <div class="content-wrapper">
            <!-- Content Header (Page header) -->
            <div class="content-header">
                <div class="container-fluid">
                    <div class="row mb-2">
                        <div class="col-sm-6">
                            <h2>DANH SÁCH DISTRICT</h2>
                        </div><!-- /.col -->
                        <div class="col-sm-6">
                            <ol class="breadcrumb float-sm-right">
                                <li class="breadcrumb-item"><a href="#">Home</a></li>
                                <li class="breadcrumb-item active">District list</li>
                            </ol>
                        </div><!-- /.col -->
                    </div><!-- /.row -->
                </div><!-- /.container-fluid -->
            </div>
            <!-- /.content-header -->

            <!-- Main content -->
            <div class="content">
                <div class="container-fluid">
                    <div class="row">
                        <button class="btn btn-primary" id="btn-create"><i class="fa-solid fa-plus"></i> &nbsp; Create
                            District</button>
                        <div class="col-12">
                            <table class="table table-bdistricted table-striped table-hover" id="district-table">
                                <thead>
                                    <tr>
                                        <th>ID</th>
                                        <th>Mã District</th>
                                        <th>Tên District</th>
                                        <th>Action</th>
                                    </tr>
                            </table>
                            <!-- Vùng Modal -->
                            <!-- Create district modal -->
                            <div>
                                <div id="create-district-modal" class="modal fade" tabindex="-1">
                                    <div class="modal-dialog">
                                        <div class="modal-content">
                                            <div class="modal-header">
                                                <h5 class="modal-title" id="h5-modal-title">Create District
                                                </h5>
                                                <button class="close" data-dismiss="modal">&times;</button>
                                            </div>
                                            <div class="modal-body">
                                                <form>
                                                    <div class="row form-group">
                                                        <div class="col-sm-3">
                                                            <label>Mã District</label>
                                                        </div>
                                                        <div class="col-sm-9">
                                                            <input type="text" id="input-create-districtCode"
                                                                class="form-control">
                                                        </div>
                                                    </div>
                                                    <div class="row form-group">
                                                        <div class="col-sm-3">
                                                            <label>Tên District</label>
                                                        </div>
                                                        <div class="col-sm-9">
                                                            <input type="text" id="input-create-districtName"
                                                                class="form-control">
                                                        </div>
                                                    </div>
                                                </form>
                                            </div>
                                            <div class="modal-footer">
                                                <button class="btn btn-secondary" id="btn-create-cancel"
                                                    data-dismiss="modal">Cancel</button>
                                                <button class="btn btn-primary" id="btn-create-district">Create
                                                    District</button>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>

                            <!-- Update district modal -->
                            <div>
                                <div id="update-district-modal" class="modal fade" tabindex="-1">
                                    <div class="modal-dialog">
                                        <div class="modal-content">
                                            <div class="modal-header">
                                                <h5 class="modal-title" id="h5-modal-title">Update Trạng Thái district
                                                </h5>
                                                <button class="close" data-dismiss="modal">&times;</button>
                                            </div>
                                            <div class="modal-body">
                                                <form>
                                                    <div class="row form-group">
                                                        <div class="col-sm-3">
                                                            <label>Mã District</label>
                                                        </div>
                                                        <div class="col-sm-9">
                                                            <input type="text" id="input-update-districtCode"
                                                                class="form-control">
                                                        </div>
                                                    </div>
                                                    <div class="row form-group">
                                                        <div class="col-sm-3">
                                                            <label>Tên District</label>
                                                        </div>
                                                        <div class="col-sm-9">
                                                            <input type="text" id="input-update-districtName"
                                                                class="form-control">
                                                        </div>
                                                    </div>
                                                </form>
                                            </div>
                                            <div class="modal-footer">
                                                <button class="btn btn-secondary" id="btn-update-cancel"
                                                    data-dismiss="modal">Cancel</button>
                                                <button class="btn btn-primary" id="btn-update-district">Update Trạng
                                                    Thái</button>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>

                            <!-- Delete confirm modal -->
                            <div>
                                <div class="modal fade" tabindex="-1" id="delete-confirm-modal">
                                    <div class="modal-dialog">
                                        <div class="modal-content">
                                            <div class="modal-header">
                                                <h5 class="modal-title" id="h5-modal-title">District Delete Confirmation
                                                </h5>
                                                <button class="close" data-dismiss="modal">&times;</button>
                                            </div>
                                            <div class="modal-body">
                                                <label>Bạn có chắc chắn muốn xóa district này không?</label>
                                            </div>
                                            <div class="modal-footer">
                                                <button class="btn btn-danger"
                                                    id="btn-confirm-delete-district">Confirm</button>
                                                <button class="btn btn-secondary" data-dismiss="modal">Cancel</button>
                                            </div>
                                        </div>
                                    </div>
                                </div>
                            </div>
                            <!-- district Detail modal -->
                            <div>

                            </div>
                        </div>
                    </div>
                    <!-- /.row -->
                </div><!-- /.container-fluid -->
            </div>
            <!-- /.content -->
        </div>
        <!-- Main Footer -->
        <footer class="main-footer">
            <!-- To the right -->
            <div class="float-right d-none d-sm-inline">
                DANH SÁCH ĐƠN HÀNG
            </div>
            <!-- Default to the left -->
            <strong>Copyright &copy; 2023 Devcamp 120.</strong> All rights
            reserved.
        </footer>
    </div>
    <!-- jQuery -->
    <script src="plugins/jquery/jquery.min.js"></script>
    <!-- Bootstrap 4 -->
    <script src="plugins/bootstrap/js/bootstrap.bundle.min.js"></script>
    <!-- AdminLTE App -->
    <script src="dist/js/adminlte.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/jquery.dataTables.min.js"></script>
    <script src="https://cdn.datatables.net/1.10.24/js/dataTables.bootstrap4.min.js"></script>
    <script>
        "use strict";
        $(document).ready(function () {
            /*** REGION 1 - Global variables - Vùng khai báo biến, hằng số, tham số TOÀN CỤC */
            const gBASE_URL = "http://localhost:8080/district/";

            const gCOLUMN_ID = 0;
            const gCOLUMN_DISTRICT_CODE = 1;
            const gCOLUMN_DISTRICT_NAME = 2;
            const gCOLUMN_ACTION = 3;


            const gCOLUMN = ["id", "districtCode", "districtName", "action"];

            var gDistrict_code = {
                id: "",
            }
            // định nghĩa table  - chưa có data
            var gdistrictTable = $("#district-table").DataTable({
                // Khai báo các cột của datatable
                "columns": [
                    { "data": gCOLUMN[gCOLUMN_ID] },
                    { "data": gCOLUMN[gCOLUMN_DISTRICT_CODE] },
                    { "data": gCOLUMN[gCOLUMN_DISTRICT_NAME] },
                    { "data": gCOLUMN[gCOLUMN_ACTION] }
                ],
                // Ghi đè nội dung của cột action, chuyển thành button chi tiết
                "columnDefs": [
                    {
                        "targets": gCOLUMN_ACTION,
                        "defaultContent": '<i class="fas fa-pen text-info edit-district"></i> &nbsp &nbsp &nbsp <i class="fas fa-trash text-danger delete-district"></i>'
                    }]
            });

            /*** REGION 2 - Vùng gán / thực thi hàm xử lý sự kiện cho các elements */
            onPageLoading();
            $("#btn-create").on("click", function () {
                $("#create-district-modal").modal("show");
            });
            $("#btn-create-district").on("click", function () {
                onCreatedistrict();
            });
            $("#district-table").on("click", ".edit-district", function () {
                onButtonChiTietClick(this); // this là button được ấn
            });
            // khi ấn nút sự kiện update trên modal
            $("#btn-update-district").on("click", function () {
                onBtnUpdateClick();
            });
            // khi ấn sự kiện delete
            $("#district-table").on("click", ".delete-district", function () {
                onBtnDeleteConfirmdistrictClick(this);
            });
            // gán sự kiện cho nút Delete  (trên modal)
            $("#btn-confirm-delete-district").on("click", function () {
                onBtnDeletedistrictClick();
            });
            /*** REGION 3 - Event handlers - Vùng khai báo các hàm xử lý sự kiện */
            // Hàm sự kiện thêm district
            function onCreatedistrict() {
                // khai báo dữ liệu
                var vdistrictObj = {
                    districtCode: "",
                    districtName: "",
                }
                // thu thập thông tin 
                getCreateData(vdistrictObj);
                // validate
                if (kiemtraCreateData(vdistrictObj)) {
                    // Tạo mới district
                    createDistrict(vdistrictObj);
                }
            }
            // hàm thu thập thông tin để create district
            function getCreateData(paramObj) {
                paramObj.districtCode = $("#input-create-districtCode").val();
                paramObj.districtName = $("#input-create-districtName").val();
            }
            function kiemtraCreateData(paramObj) {
                if (paramObj.districtCode == "") {
                    alert("Bạn điền mã district không hợp lệ")
                    return false;
                }
                if (paramObj.districtName == "") {
                    alert("Bạn điền tên district không hợp lệ")
                    return false;
                }
                return true;
            }
            //Hàm tạo đơn mói
            function createDistrict(paramObj) {
                var vUrlString = window.location.href; //đường đẫn gọi đến trang
                var vUrl = new URL(vUrlString);
                var vID = vUrl.searchParams.get("id");
                $.ajax({
                    url: gBASE_URL + "create/" + vID,
                    type: 'POST',
                    data: JSON.stringify(paramObj),
                    contentType: "application/json; charset=utf-8",
                    dataType: 'json',
                    success: function (paramObjdistrict) {
                        //hiển thị dữ liệu lên web
                        console.log(paramObjdistrict);
                        onPageLoading();
                        $("#create-district-modal").modal("hide");
                        alert("Bạn tạo thành công district");
                        $("#input-create-districtCode").val("");
                        $("#input-create-districtName").val("");
                    },
                    error: function (error) {
                        alert("Bạn tạo district thất bại!");
                        console.log(error.responseText)
                    }
                });
            }
            // infoFunction sẽ là function các nút cùng gọi
            function onButtonChiTietClick(paramChiTietButton) {
                //Xác định thẻ tr là cha của nút được chọn
                var vRowSelected = $(paramChiTietButton).parents('tr');
                //Lấy datatable row
                var vDatatableRow = gdistrictTable.row(vRowSelected);
                //Lấy data của dòng 
                var vdistrictData = vDatatableRow.data();
                gDistrict_code.id = vdistrictData.id;
                // lấy api để load vào modal
                getdistrictbydistrictID();
                $("#update-district-modal").modal("show");
            }
            function getdistrictbydistrictID() {
                $.ajax({
                    url: "http://localhost:8080/district/details/" + gDistrict_code.id,
                    type: "GET",
                    dataType: 'json',
                    success: function (responseObject) {
                        //debugger;
                        loadDataToModal(responseObject);
                    },
                    error: function (error) {
                        console.assert(error.responseText);
                    }
                });
            }
            // hàm load data to modal update
            function loadDataToModal(paramResponseObject) {
                $("#input-update-districtCode").val(paramResponseObject.districtCode);
                $("#input-update-districtName").val(paramResponseObject.districtName);
            }
            function onPageLoading() {

                //Khai báo dữ liệu
                //validate
                // lấy data từ server
                getAlldistrictbyapi();
                // Xử lý front-end
            }

            /*** REGION 4 - Common funtions - Vùng khai báo hàm dùng chung trong toàn bộ chương trình */
            function getAlldistrictbyapi() {
                //gán dữ liệu
                var vUrlString = window.location.href; //đường đẫn gọi đến trang
                var vUrl = new URL(vUrlString);
                var vID = vUrl.searchParams.get("id");
                var vKD = vUrl.searchParams.get("kd");
                $(".click-region").attr("href", "Region.html?id=" + vKD)
                var vValid = kiemtraID(vID,vKD);
                if (vValid) {
                    $.ajax({
                        url: "http://localhost:8080/region/" + vID + "/districts",
                        type: "GET",
                        dataType: 'json',
                        success: function (responseObject) {
                            //debugger;
                            loadDataToTable(responseObject);
                        },
                        error: function (error) {
                            console.assert(error.responseText);
                            //window.location.href = "Region.html?id=" + vKD;
                        }
                    });
                }
            }
            //hàm kiểm tra ID
            function kiemtraID(paramID,paramKD) {
                if (paramID == null || paramID == "") {
                    alert("QueryString không có ID");
                    //window.location.href = "Region.html?id=" + paramKD;
                    return false;
                }
                if (paramKD == null || paramKD == "") {
                    alert("QueryString không có KD");
                    //window.location.href = "Region.html?id=" + paramKD;
                    return false;
                }
                return true;
            }
            // load data to table
            function loadDataToTable(paramResponseObject) {
                //Xóa toàn bộ dữ liệu đang có của bảng
                gdistrictTable.clear();
                //Cập nhật data cho bảng 
                gdistrictTable.rows.add(paramResponseObject);
                //Cập nhật lại giao diện hiển thị bảng
                gdistrictTable.draw();
            }
            // khi bấm nút Update trên modal
            function onBtnUpdateClick() {
                console.log(gDistrict_code.id);
                //khai báo dữ liệu
                var vObjectRequest = {
                    districtCode: "",
                    districtName: ""
                }
                // gán dữ liệu
                vObjectRequest.districtCode = $("#input-update-districtCode").val();
                vObjectRequest.districtName = $("#input-update-districtName").val();
                //validate
                var validate = kiemtraCreateData(vObjectRequest);
                if (validate) {
                    //cập nhật trạng thái
                    updatedistrict(vObjectRequest);
                }
            }
            //update district
            function updatedistrict(paramObj) {
                $.ajax({
                    url: gBASE_URL + "update/" + gDistrict_code.id,
                    type: "PUT",
                    data: JSON.stringify(paramObj),
                    contentType: "application/json; charset=utf-8",
                    dataType: 'json',
                    success: function (responseObject) {
                        //debugger;
                        handleUpdatetSuccess(responseObject.id);
                    },
                    error: function (error) {
                        console.assert(error.responseText);
                    }
                });
            }
            // hàm xử lý sự kiện delete district modal click
            function onBtnDeletedistrictClick() {
                //khai báo dữ liệu
                //validate
                //gọi api
                $.ajax({
                    url: gBASE_URL + "delete/" + gDistrict_code.id,
                    type: "DELETE",
                    contentType: "application/json; charset=utf-8",
                    success: function (paramRes) {
                        // B4: xử lý front-end
                        handleDeletedistrictSuccess();
                    },
                    error: function (paramErr) {
                        console.log(paramErr.status);
                    }
                });
                //hiển thị thông tin
            }
            // hàm xử lý hiển thị front-end khi update Trạng thái thành công
            function handleUpdatetSuccess(paramObj) {
                onPageLoading();
                alert("Update district Id = " + paramObj + " thành công!");
                $("#update-district-modal").modal("hide");
            }
            // hàm xử lý hiển thị front-end khi sửa district thành công
            function handleDeletedistrictSuccess() {
                onPageLoading();
                alert("Xóa district thành công!");
                $("#delete-confirm-modal").modal("hide");
            }
            function onBtnDeleteConfirmdistrictClick(paramChiTietButton) {
                //Xác định thẻ tr là cha của nút được chọn
                var vRowSelected = $(paramChiTietButton).parents('tr');
                //Lấy datatable row
                var vDatatableRow = gdistrictTable.row(vRowSelected);
                //Lấy data của dòng 
                var vdistrictData = vDatatableRow.data();
                gDistrict_code.id = vdistrictData.id;
                // lấy api để load vào modal
                $("#delete-confirm-modal").modal("show");
            }
        });
    </script>
</body>

</html>